#ifndef __RF_H
#define __RF_H

#define PAYLOAD_WIDTH   	8		//XN297Lͽݿȶ

RD_REG				EQU	0x00
WR_REG				EQU	0x20
RD_RX_PLOAD			EQU	0x61
WR_TX_PLOAD			EQU	0xA0
FLUSH_TX			EQU	0xE1
FLUSH_RX			EQU	0xE2
REUSE_TX_PL			EQU	0xE3
ACTIVATE			EQU	0x50
RD_RX_PL_WID		EQU	0x60
WR_ACK_PLOAD		EQU	0xA8
WR_NO_ACK_PLOAD		EQU	0xB0
NOPCMD				EQU	0xFF
CE_FSPI_ON			EQU	0b1111_1101
CE_FSPI_OFF			EQU	0b1111_1100
RST_FSPI_HOLD		EQU	0b01010011
RST_FSPI_RELS		EQU	0b01010011
RSTDATA				EQU	0x5A
NORDATA				EQU	0xA5

//REG TABLE
CONFIG				EQU	0x00
EN_AA				EQU	0x01
EN_RXADDR			EQU	0x02
SETUP_AW			EQU	0x03
SETUP_RETR			EQU	0x04
RF_CH				EQU	0x05
RF_SETUP			EQU	0x06
STATUS				EQU	0x07
OBSERVE_TX			EQU	0x08
DATAOUT				EQU	0x09
RX_ADDR_P0			EQU	0x0A
RX_ADDR_P1			EQU	0x0B
RX_ADDR_P2			EQU	0x0C
RX_ADDR_P3			EQU	0x0D
RX_ADDR_P4			EQU	0x0E
RX_ADDR_P5			EQU	0x0F
TX_ADDR				EQU	0x10
RX_PW_P0			EQU	0x11
RX_PW_P1			EQU	0x12
RX_PW_P2			EQU	0x13
RX_PW_P3			EQU	0x14
RX_PW_P4			EQU	0x15
RX_PW_P5			EQU	0x16
FIFO_STATUS			EQU	0x17
DMD_CAL				EQU	0x19
RF_CAL2				EQU	0x1A
DEM_CAL2			EQU	0x1B
DYNPD				EQU	0x1C
FEATURE				EQU	0x1D
RF_CAL				EQU	0x1E
BB_CAL				EQU	0x1F

#define         rf13dBm                         0x3F                            // 13dBm 
#define         rf10dBm                         0X17                            // 10dBm 
#define         rf8dBm                          0x15                            // 8dbm   
#define         rf7dBm                          0x07                            // 7dbm   
#define         rf5dBm                          0x2c                            // 5dbm 
#define         rf4dBm                          0x06                            // 4dbm   
#define         rf2dBm                          0x05                            // 2dbm  
#define         rf0dBm                          0X0B                            // 0dBm 



#define         DR_1M                          0X00				//ͨѶ 1Mbps
#define         DR_2M                          0X40				//ͨѶ 2Mbps
#define         DR_250K                        0XC0				//ͨѶ 250K

//========================================//
//IO define
CSN		EQU	PB.4
SCK		EQU	PB.3
MOSI	EQU	PB.2
MISO	EQU	PB.1
IRQ		EQU	PB.0

extern word p_buf;//ָ룬ָ򻺳
extern byte tmp;//ʱڸʱ
extern byte channel;//ͨҪͨл
extern byte length;//ڸ궨弴޼Ĳ
extern byte spi_buf;//spiдĻ
extern byte spibuf[5];

//**************************//
//**************************//
extern void tx_pkt(void);//һ
extern void rx_pkt(void);//һ
extern void rf_init(void);//оƬʼ
extern void dly1ms(void);//ʱ1ms
extern void spi_rw(void);//spiд
extern void spi_rdbuf(void);//ȡ
extern void spi_wrbuf(void);//д
extern void getrf_status(void);//״̬
extern void set_CE(void);//CE
extern void clear_CE(void);//CE
extern void rf_set_channel(void);//ŵ
extern void rf_tx_mode(void);//ģʽ
extern void rf_rx_mode(void);//ģʽ
extern void rf_tx_flush(void);//巢ͻ
extern void rf_rx_flush(void);//ջ
extern void setrfaw(void);//ýտ
extern void rf_clear_status(void);//״̬
extern void rf_rst(void);//ƵоƬλ
extern void rf_io_init(void);//ƵоƬIOʼ
extern void RF_CAL2_1M_tab(void);//RF_CAL2 1Mñ
extern void RF_CAL2_250K_tab(void);//RF_CAL2 250Kñ
extern void BB_CAL_1M_tab(void);//BB_CAL 1Mñ
extern void BB_CAL_250K_tab(void);//BB_CAL 250Kñ
extern void RF_CAL_tab(void);//RF_CALñ
extern void DEM_CAL2_tab(void);//DEM_CAL2ñ
extern void RF_Power_off(void);
extern void RF_CAL_tab(void);//RF_CALñ
extern void DEM_CAL2_tab(void);//DEM_CAL2ñ
extern void RF_Channel_tab(void);

//궨壬Դݲ
//*************************// 
// 
//************************//

DELAYNMS macro nms			//ʱnmsʱ:nmsΪbyteΧ
{
#if	nms>256
	.error DELAYNMS must less than 256;
#endif
	tmp = nms;
	call dly1ms;
}
endm

READRFREG macro rf_reg,reg_value		//ȡrfregĴһֽ
{
	CSN = 0;
	spi_buf = rf_reg;
	call spi_rw;
	spi_buf = 0;
	call spi_rw;
	CSN = 1;
	reg_value=spi_buf;
}
endm

READRFBUF macro rf_reg,rx_buf,len		//ȡrfregĴֽ
{
	p_buf = rx_buf;
	length = len;
	spi_buf = rf_reg;
	call spi_rdbuf;
}
endm

RF_SET_CH macro chn		//ŵ
{
	channel=chn;
	call rf_set_channel;
}
endm

RX_SETLEN macro plength	//趨pipeݳ
{
	CSN = 0;
	spi_buf = WR_REG|0x11;
	call spi_rw;
	spi_buf = plength;
	call spi_rw;
	CSN = 1;
}
endm

SETRATEPWR macro rate_pwr		//趨ʺͷ书:Ҫ趨ֵ
{
	CSN = 0;
	spi_buf = WR_REG|RF_SETUP;
	call spi_rw;
	spi_buf = rate_pwr;
	call spi_rw;
	CSN = 1;
}
endm

TX_SETADDR macro adrlen,adr//趨RFͨŵַ,ǵַ,ΪҲΪconst
{
#if (adrlen>0x03||adrlen==0)
	.error adrlen must be 1:3byte,2:4byte,3:5byte;
#else
	length = adrlen;
	call setrfaw;
#endif
	length = adrlen + 2;
	p_buf = adr;
	spi_buf = TX_ADDR|WR_REG;
	call spi_wrbuf;		//÷ַ,Ҫѵַдspibuf[0]--spibuf[4]
}
endm
	
	
RX_SETADDR macro adrlen,adr//趨RFͨŵַ,ǵַ,ΪҲΪconst
{
#if (adrlen>0x03||adrlen==0)
	.error adrlen must be 1:3byte,2:4byte,3:5byte;
#else
	length = adrlen;
	call setrfaw;
#endif
	length = adrlen + 2;
	p_buf = adr;
	spi_buf = RX_ADDR_P0|WR_REG;
	call spi_wrbuf;
}
endm
	
TX_PACKET macro dat_len,p_tx_buf	//÷亯ûָݰ׵ַ
{
	p_buf = p_tx_buf;
	length = dat_len;
	call tx_pkt;
}
endm

RX_PACKET macro dat_len,p_rx_buf	//ýպûָյݱ׵ַ
{
	p_buf = p_rx_buf;
	length = dat_len;
	call rx_pkt;
}
endm

PWM1_INIT macro control,period,duty//pwm1ʼ
{
#if	duty>256
	.error duty must less than 256;
#endif
	//$	PA.3  out,low;
	tm2ct=0x00;//Ĵ㼴
	tm2c=control;//ƼĴƼʹֵΪ0x1a,ϵͳʱӣ=PA3,pwmģʽ
	tm2s=period;//ƵĴƼʹֵΪ0x00,ƵΪ15.625K
	tm2b=duty;//ռձ
}
endm

PWM2_INIT macro control,period,duty//pwm2ʼ
{
#if	duty>256
	.error duty must less than 256;
#endif
	//$	PB.5  out,low;
	tm3ct=0x00;//Ĵ㼴
	tm3c=control;//ƼĴƼʹֵΪ0x16,ϵͳʱӣ=PB5,pwmģʽ
	tm3s=period;//ƵĴƼʹֵΪ0x00,ƵΪ15.625K
	tm3b=duty;//ռձ
}
endm

SET_PWM1_DUTY macro duty//pwm1ռձ
{
//#if	duty>256
//	.error duty must less than 256;
//#endif
	tm2b=duty;//ռձ
}
endm

SET_PWM2_DUTY macro duty//pwm2ռձ
{
//#if	duty>256
//	.error duty must less than 256;
//#endif
	tm3b=duty;//ռձ
}
endm

GET_PWM1_DUTY macro p_duty//ȡpwm1ռձ
{
	*pduty=tm2b;//ռձ
}
endm

GET_PWM2_DUTY macro p_duty//ȡpwm2ռձ
{
	*pduty=tm3b;//ռձ
}
endm

SET_RF_CAL2 macro rate //RF_CAL2
{
	byte i;
	i=6;
	CSN = 0;
	spi_buf = RF_CAL2|WR_REG;
	call spi_rw;
	if(rate == DR_1M)
	{
		while(i)
		{
			a = i;
			RF_CAL2_1M_tab();
			spi_buf = a;
			call spi_rw;
			i--;
		}
	}
	else if(rate == DR_250K)
	{
		while(i)
		{
			a = i;
			RF_CAL2_250K_tab();
			spi_buf = a;
			call spi_rw;
			i--;
		}
	}
	CSN = 1;
}
endm

SET_BB_CAL macro rate //BB_CAL
{
	byte i;
	i=5;
	CSN = 0;
	spi_buf = BB_CAL|WR_REG;
	call spi_rw;
	if(rate == DR_1M)
	{
		while(i)
		{
			a = i;
			BB_CAL_1M_tab();
			spi_buf = a;
			call spi_rw;
			i--;
		}
	}
	else if(rate == DR_250K)
	{
		while(i)
		{
			a = i;
			BB_CAL_250K_tab();
			spi_buf = a;
			call spi_rw;
			i--;
		}
	}
	CSN = 1;
}
endm

SET_RF_CAL macro  //RF_CAL
{
	byte i;
	i=3;
	CSN = 0;
	spi_buf = RF_CAL|WR_REG;
	call spi_rw;
	while(i)
	{
		a = i;
		RF_CAL_tab();
		spi_buf = a;
		call spi_rw;
		i--;
	}
	CSN = 1;
}
endm

SET_DEM_CAL2 macro  //DEM_CAL2
{
	byte i;
	i=3;
	CSN = 0;
	spi_buf = DEM_CAL2|WR_REG;
	call spi_rw;
	while(i)
	{
		a = i;
		DEM_CAL2_tab();
		spi_buf = a;
		call spi_rw;
		i--;
	}
	CSN = 1;
}
endm

SET_TX_ADDR macro  //DEM_CAL2
{
	byte i;
	i=5;
	CSN = 0;
	spi_buf = TX_ADDR|WR_REG;
	call spi_rw;
	while(i)
	{
		a = i;
		TX_ADDR_tab();
		spi_buf = a;
		call spi_rw;
		i--;
	}
	CSN = 1;
}
endm

SET_RX_ADDR_P0 macro  //DEM_CAL2
{
	byte i;
	i=5;
	CSN = 0;
	spi_buf =RX_ADDR_P0|WR_REG;
	call spi_rw;
	while(i)
	{
		a = i;
		RX_ADDR_P0_tab();
		spi_buf = a;
		call spi_rw;
		i--;
	}
	CSN = 1;
}
endm


SET_DEM_CAL macro value//DEM_CAL
{
	CSN = 0;
	spi_buf = DMD_CAL | WR_REG;
	call spi_rw;
	spi_buf = value;
	call spi_rw;
	CSN = 1;
}
endm



#endif
